%define _prefix /opt/xserver13
# I messed up the version numbers...
Epoch: 1

%define with_debug 0
%define kdrive_builds_vesa 0

%define mesasrcdir /usr/src/Mesa

%ifarch %{ix86} alpha
%define kdrive_builds_vesa 1
%endif

%define name x11-server13
%define version 1.2.99.903
%define git 0
%if %git
%define release %mkrel 0.rc1.%git.2
%else
%define release %mkrel 1
%endif

Name: %{name}
Version: %{version}
Release: %{release}
Summary:  X11 servers
Group: System/X11
%if %git
Source: xorg-server-%{git}.tar.bz2
%else
Source: http://xorg.freedesktop.org/releases/individual/xserver/xorg-server-%{version}.tar.bz2
%endif
Source1: xserver.pamd
License: MIT
BuildRoot: %{_tmppath}/%{name}-root

BuildRequires: libdmx-devel >= 1.0.1
BuildRequires: libfontenc-devel >= 1.0.1
BuildRequires: liblbxutil-devel >= 1.0.0
BuildRequires: libmesagl-devel >= 6.4.2
BuildRequires: libxau-devel >= 1.0.0
BuildRequires: libxaw-devel >= 1.0.1
BuildRequires: libxdmcp-devel >= 1.0.0
BuildRequires: libxext-devel >= 1.0.0
BuildRequires: libxfont-devel >= 1.0.0
BuildRequires: libxfixes-devel
BuildRequires: libxi-devel >= 1.0.0
BuildRequires: libxkbfile-devel >= 1.0.1
BuildRequires: libxau-devel >= 1.0.0
BuildRequires: libxkbui-devel >= 1.0.1
BuildRequires: libxmu-devel >= 1.0.0
BuildRequires: libxpm-devel >= 3.5.4.2
BuildRequires: libxrender-devel >= 0.9.0.2
BuildRequires: libxres-devel >= 1.0.0
BuildRequires: libxtst-devel >= 1.0.1
BuildRequires: libxxf86misc-devel >= 1.0.0
BuildRequires: libxxf86vm-devel >= 1.0.0
BuildRequires: mesa-source >= 6.5.1
BuildRequires: libxfont-devel >= 1.0.0
BuildRequires: x11-proto-devel >= 1.0.3-2
BuildRequires: x11-util-macros >= 1.0.1
BuildRequires: x11-xtrans-devel >= 1.0.0
BuildRequires: libdmx-devel >= 1.0.1
BuildRequires: libpam-devel
BuildRequires: SDL-devel
# for VNC:
BuildRequires: libjpeg-devel


# --------- Patches ----------------------------------------------------------
Patch3:  0003-Use-a-X-wrapper-that-uses-pam-and-consolehelper-to-give-X-root-privileges.txt
Patch4:  0004-Blue-background-on-startup.txt
Patch7:  0007-find-free-VT.txt
Patch9:  0009-GL-include-inferiors.txt
Patch10: 0010-Xephyr-evdev-support.txt 
Patch17: 0017-Fix-index-matching-of-visuals.txt 
Patch18: 0018-vnc-support.txt 
Patch32: 0032-no-move-damage.txt
Patch33: 0033-dont-backfill-bg-none.txt
Patch34: 0034-offscreen-pixmaps.txt
Patch37: 0037-fdo8991-xorg-server-1.1.99.901-glXDRIbindTexImage-target.txt
Patch38: 0038-fdo9367-libdrm-ignore-load-requests-fixes-fglrx.txt

# -----------------------------------------------------------------------------

Requires: %{name}-xorg

%description
Experimental build of the xserver-1.3-branch of the Xorg git repository.

This server adds RandR 1.2 functionality to the server which will allow
for dynamic adding/removing of the monitors/displays without restarting
X

This currently only works reliably with Intel hardware and the special
x11-driver-video-intel13 driver package.

You need to Modify you /etc/X11/xorg.conf to add:

 ModulePath "%_libdir/xorg/modules,/usr/%_lib/xorg/modules"

to the Files Section.

Happy hacking.

#------------------------------------------------------------------------------

%package devel
Summary: Development files for %{name}
Group: Development/X11
License: MIT

Requires: %{name} >= %{epoch}:%{version}

%define oldxorgnamedevel  %mklibname xorg-x11
Conflicts: %{oldxorgnamedevel}-devel < 7.0

%description devel
Development files for %{name}

%pre devel
if [ -h %{_includedir}/X11 ]; then
	rm -f %{_includedir}/X11
fi

%files devel
%defattr(-,root,root)
%dir %{_includedir}
%dir %{_includedir}/xorg
%dir %{_includedir}/X11/bitmaps
%dir %{_includedir}/X11/pixmaps
%dir %{_libdir}/pkgconfig
%dir %{_datadir}/aclocal
%{_includedir}/xorg/*.h
%{_includedir}/X11/bitmaps/*
%{_includedir}/X11/pixmaps/*
%{_libdir}/pkgconfig/xorg-server.pc
%{_datadir}/aclocal/xorg-server.m4

#------------------------------------------------------------------------------

%package common
Summary: X server common files
Group: System/X11
License: MIT
Provides: XFree86 = 7.0.0
Conflicts:     xorg-x11 <= 6.9.0-12mdk
Requires: rgb
# for 'fixed' and 'cursor' fonts
Requires: x11-font-misc-misc
Requires: x11-font-cursor-misc
Requires: x11-font-alias                                                  

%description common
X server common files

%files common
%defattr(-,root,root)
%dir %{_prefix}
%dir %{_bindir}
%dir %{_libdir}
%dir %{_libdir}/X11
%dir %{_libdir}/xorg
%dir %{_libdir}/xorg/modules
%dir %{_libdir}/xserver
%dir %{_datadir}
%dir %{_mandir}
%dir %{_mandir}/man1
%dir %{_mandir}/man4
%{_bindir}/xorgcfg
%{_bindir}/xorgconfig
%{_bindir}/xkbcomp
%{_bindir}/gtf
%{_bindir}/cvt
%{_bindir}/in*
%{_bindir}/ioport
%{_bindir}/out*
%{_bindir}/pcitweak
%{_bindir}/scanpci
#%{_bindir}/vdltodmx
%{_libdir}/X11/Cards
%{_libdir}/X11/Options
#%{_libdir}/X11/xserver/*
%{_libdir}/xorg/modules/*
%{_libdir}/xserver/SecurityPolicy
#%{_datadir}/X11/xkb
%{_mandir}/man1/xorgcfg.*
%{_mandir}/man1/xorgconfig.*
%{_mandir}/man1/gtf.*
%{_mandir}/man1/cvt.1
%{_mandir}/man1/pcitweak.*
%{_mandir}/man1/scanpci.*
#%{_mandir}/man1/vdltodmx.*
%{_mandir}/man4/fbdevhw.4
%{_mandir}/man4/exa.4
#exclude %{_libdir}/X11/xserver/C

#------------------------------------------------------------------------------

%package xorg
Summary: X.org X11 server
Group: System/X11
License: MIT
Requires: %{name}-common = %{epoch}:%{version}-%{release}
Requires: x11-data-xkbdata >= 1.0.1 
Requires: x11-font-alias
Requires: libx11-common
Requires: x11-driver-input-mouse
Requires: x11-driver-input-keyboard
#Obsoletes: xorg-x11-server < 7.0
#Provides: xorg-x11-server = 7.0

%description xorg
x11-server-xorg is the new generation of X server from X.Org.

%files xorg
%defattr(-,root,root)
%dir %{_mandir}/man5
%{_bindir}/X
%{_bindir}/Xorg
%attr(4755,root,root)%{_bindir}/Xwrapper
#%{_sysconfdir}/X11/X
#%{_sysconfdir}/pam.d/xserver
#%{_sysconfdir}/security/console.apps/xserver
#%{_datadir}/X11/app-defaults/XOrgCfg
%{_mandir}/man1/Xorg.*
%{_mandir}/man1/Xserver.*
%{_mandir}/man5/xorg.conf.*

#------------------------------------------------------------------------------

%prep
%if %git
%setup -q -n xserver
%else
%setup -q -n xorg-server-%{version}
%endif

#patches
%patch3  -p1 -b .xwrapper
%patch4  -p1 -b .blue_bg
%patch7  -p1 -b .vt7
%patch9  -p1 -b .gl_include_inferiors
%patch10 -p1 -b .evdev
%patch17 -p1 -b .visual_index_matching
#patch18 -p1 -b .vnc
%patch32 -p0 -b .no_move_damage
%patch33 -p0 -b .dont_backfill
%patch34 -p0 -b .offscreen_pixmaps
%patch37 -p1 -b .glxdribindteximage
%patch38 -p0 -b .libdrm_fix

%build
PKG_CONFIG_PATH=%{_libdir}/pkgconfig:$PKG_CONFIG_DIR
export PKG_CONFIG_PATH
%if %git
./autogen.sh
%else
aclocal && autoconf && automake
%endif
%configure2_5x  --with-log-dir=%{_logdir} \
		%if %{with_debug}
  		--enable-debug \
		%else
		--disable-debug \
		%endif
 		--enable-builddocs \
  		--disable-install-libxf86config \
  		--enable-composite \
  		--enable-shm \
  		--enable-xres \
  		--enable-xtrap \
  		--enable-record \
  		--enable-xv \
  		--enable-xvmc \
  		--enable-dga \
  		--enable-screensaver \
  		--enable-xdmcp \
  		--enable-xdm-auth-1 \
  		--enable-glx \
  		--enable-aiglx \
  		--enable-glx-tls \
  		--enable-dri \
		--with-mesa-source=%{mesasrcdir} \
  		--enable-xinerama \
  		--enable-xf86vidmode \
  		--enable-xf86misc \
  		--enable-xcsecurity \
		--enable-xevie \
  		--enable-lbx \
  		--enable-appgroup \
  		--enable-cup \
  		--enable-evi \
  		--enable-xf86bigfont \
  		--enable-dpms \
  		--enable-xinput \
  		--enable-multibuffer \
  		--enable-fontcache \
  		--enable-dbe \
  		--enable-xorg \
  		--enable-xorg-vnc \
  		--disable-dmx \
  		--disable-xdmx-vnc \
  		--disable-xvfb \
		--disable-xnest \
  		--disable-xwin \
  		--disable-xprint \
  		--disable-xgl \
  		--disable-xglx \
  		--disable-xegl \
  		--disable-kdrive \
  		--disable-xephyr \
  		--enable-xsdl \
  		--disable-freetype \
  		--disable-install-setuid \
 		--enable-secure-rpc \
  		--enable-xorgcfg \
  		--enable-kbd_mode \
		--enable-xwrapper \
		--enable-pam \
		--with-fontdir=/usr/share/fonts \
		--with-default-font-path="/usr/share/fonts/misc:unscaled,unix/:-1" \
		--with-dri-driver-path=/usr/%{_lib}/dri \
		--with-xkb-path=/usr/share/X11/xkb \
		--with-xkb-output=/usr/share/X11/xkb/compiled
# parallel build broken
make

%install
rm -rf %{buildroot}
%makeinstall_std
mkdir -p %{buildroot}%{_sysconfdir}/X11/
#ln -s %{_bindir}/Xorg %{buildroot}%{_sysconfdir}/X11/X
ln -sf %{_bindir}/Xwrapper %{buildroot}%{_bindir}/X

#mkdir -p %{buildroot}%{_sysconfdir}/pam.d
#install -m 0644 %{_sourcedir}/xserver.pamd %{buildroot}%{_sysconfdir}/pam.d/xserver     
#mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps
#touch %{buildroot}%{_sysconfdir}/security/console.apps/xserver

# move README.compiled outside compiled/ dir, so there won't be any problem with x11-data-xkbdata
#mv -f %{buildroot}%{_datadir}/X11/xkb/compiled/README.compiled %{buildroot}%{_datadir}/X11/xkb/
# Remove the README.compiled
rm -rf %{buildroot}/usr/share/X11/xkb/

rm -f %{buildroot}/usr/share/X11/app-defaults/XOrgCfg

# This is needed for some reason
ln -s /usr/bin/xkbcomp %{buildroot}%{_bindir}/xkbcomp

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)



%changelog
* Tue Mar 27 2007 Colin Guthrie <cguthrie@mandriva.org> 1.2.99.903-1mdv2007.1
+ Revision: 149097
- New Release Candidate (RC3)

* Wed Mar 14 2007 Colin Guthrie <cguthrie@mandriva.org> 1:1.2.99.902-1mdv2007.1
+ Revision: 143893
- New release 1.2.99.902 (1.3 RC2)

* Mon Mar 12 2007 Anssi Hannula <anssi@mandriva.org> 1.3.0-0.rc1.20070308.2mdv2007.1
+ Revision: 141877
- own all directories in own prefix (#29350)

* Thu Mar 08 2007 Adam Williamson <awilliamson@mandriva.com> 1.3.0-0.rc1.20070308.1mdv2007.1
+ Revision: 138508
- disable parallel build
- git 20070308 - needed for updated driver

* Mon Mar 05 2007 Adam Williamson <awilliamson@mandriva.com> 1.3.0-0.rc1.1mdv2007.1
+ Revision: 132916
- fix build (Xwrapper patch)
- 1.3.0rc1

* Fri Mar 02 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 1.3.0-0.git20070223.1mdv2007.1
+ Revision: 131352
- updated blue background patch to explicitelly say we use a background color
  and not a tile pixmap

* Fri Mar 02 2007 Colin Guthrie <cguthrie@mandriva.org> 1.3.0-0.git20070223.0mdv2007.1
+ Revision: 130918
- Fix DRI Path
- Fix Keyboard issues
- Fix default font paths
- Update to the git snapshot of server-1.3-branch
- Make a branch of our official Xorg x11-server package for x11-server13 branch
- Rebuild against libxrandr 1.2
- Drop upstream applied patches
- New release: 1.2.0
- Rediff VNC patch + Fixes from Stefan Dirsch @ SuSE
- Try to fix #28271
- Add ugly work around to ignore requests to load drm module until new fglrx driver is released.
- Add patches to fix various compositing issues with compiz/beryl etc.
- Update patches for new version
- Remove patches merged upstream
- Adjust file lists for new version
- Quick and dirty hack to remove Xsession.d file for now
- Update to 1.1.99.903 (Xorg 7.2 RC3)

  + Gustavo Pichorim Boiko <boiko@mandriva.com>
    - make the randr extension report only the version it really supports
    - Imported the vnc patch into the mandriva git tree
    - Added a patch fixing crashed when closing laptop lid (#26997)
    - Added a patch that fixes the index matching of the two arrays of visuals
      (this fixes some crashes on SiS and Via chipsets)
    - Backported some fixes from the upstream git repository:
       * Adds support for Xephyr to simulate 8bit grayscale
       * Really disable composite in Xprt (as it doesn't support it)
       * Fix some BadLenght errors in Xdmx render implementation
       * Fix the Linux ACPI reopen code to use a repeating timer instead of a
         sleep and retry.
       * Fix a RandR screen size problem when rotating fails.
       * Fix a segfault on broken Xinerama configs
       * Some x86_64 fixes
       * Handle scaled identity matrix in SetPictureTransform
       * Added some missing defines for Xdmx to work right
       * Check if the visual is null in Xdmx to prevent crashes
    - Added a patch to use autoconf to get the correct name of a struct member.
      This allows removing the kernel version ifdefs from the code. It also fixes
      compilation on sparc.
    - Xorg needs core input devices (#23062)
    - applied patches 0014 and 0015 in the git repository, and reformatted them
    - readd damage tracking support for tfp in AIGLX
    - add support for mesa to copy subbuffers when subtexturing
    - new upstream release (1.1.1):
        * Delete a (now misleading) message from the crash handler.
        * Switch the default mouse device on Linux to /dev/input/mice.
        * PPC64 build fix.
        * Generate xprint.pre from xprint.cpp.
        * Remove hardcoded 'lib' in XPRINTDIR.
        * Fix MMX Saturate implementation.
        * Freedesktop Bug #7366: Fix two crashes in operations on source pictures.
        * Freedesktop Bug #7366: Fix crashes when setting filters on source pictures.
        * Fix bugs in support for new repeatTypes in XAA and EXA.
        * Correct AGP memory deallocation argument on *BSD.
        * Move EXA_PM_IS_SOLID() to the public API, since drivers will want it frequently.
        * Correct component ordering when fetching [ax]4b4g4r4 pixels.
        * Fix crash when using PICT_x4a4 by supplying an appropriate fbFetchPixel_x4a4.
        * Freedesktop Bugzilla #5120, #7246: In CW's GC ops, validate the backing GC against the
        * Don't try to dist the .cvsignore files.
        * Bump package version to 1.1.1 for release, and vendor release to 7.1.1.0.
        * Pull over convolution filter fixes from xgl-0-0-1 branch.
        * Freedesktop bug #2488 for fb too: sample pixel center when transforming.
        * Check setuid() return value. Freedesktop Bugzilla #7116.
        * Fix byte swapping in some GLX requests.
        * Freedesktop Bug #7213: Fix the XFree86-DRI extension for byte-swapped clients.
    - Removed convolution filter patches: applied upstream
    - Removed check setuid return patches: applied upstream
    - Enable DPMS (by fixing the configure script)
    - Removed the FIXME lines. All fixed.
    - Added a patch providing evdev support for the Xephyr kdrive server. It is used
      for multihead/multiseat solutions
    - removed the patch for damage support in tfp (it is not working fine yet)
    - added a patch fixing the software fallback convolution filter
      (fix the shadows when using compiz for example)
    - added a patch checking the return value of setuid
    - Use git to manage xorg patches
    - Added patches fixing AIGLX (documentation for each patch is inside the patch
      file).
        * GL include inferiors
        * AIGLX tfp damage tracking
    - Added patches optimizing the PCI scanning process
      (backported from development tree)
    - removed old unused patch (Xorg-6.7.0-isolate_device)
    - rebuild to fix x86_64 compilation
    - added patch: try to find an empty VT to start the X server
    - removed old tarball
    - fixed patch for lbx symbols. The buildorder was wrong
    - added a patch fixing some missing lbx linking options when compiling kdrive
    - enabled kdrive support. this enable the compilation of the following servers:
        * x11-server-xati
        * x11-server-xchips
        * x11-server-xephyr
        * x11-server-xepson
        * x11-server-xfake
        * x11-server-xfbdev
        * x11-server-xi810
        * x11-server-xmach64
        * x11-server-xmga
        * x11-server-xneomagic
        * x11-server-xnvidia
        * x11-server-xpm2
        * x11-server-xr128
        * x11-server-xsdl
        * x11-server-xsmi
        * x11-server-xvesa
        * x11-server-xvia
    - rebuild to fix cooker uploading
    - X11R7.1
    - KDrive is not building fine, so it is disabled for now. It will be re-enabled
      as soon as I get it to compile.
    - 6mdk
    - Moved README.compiled out of compiled dir
    - Added /etc/security/console.apps/xserver
      (Thanks Laurent for the report)
    - Added version to the XFree86 provide
    - Add packager tag
    - Add missing XFree86 provide tag to x11-server-common
    - added missing buildrequires
    - disabling some obsoletes/provides for now to test another update strategy
    - increment release
    - Adding X.org 7.0 to the repository

  + Gwenole Beauchesne <gbeauchesne@mandriva.com>
    - fix buildrequires (mesa-source >= 6.5.1 / arrayobj.c)

  + Christiaan Welvaart <spturtle@mandriva.org>
    - bump release
    - fix build problems with vnc patch
    - add BuildRequires: libjpeg-devel
    - patch0: add vnc module and Xvnc
    - VNC support, adapted from http://xf4vnc.sourceforge.net/ CVS
    - fix filelist for archs where kdrive vesa and derived servers are not built
    - Added dependency on x11-server-common to all server packages,
      added some dependencies to x11-server-common so the servers
      can find the fixed and cursor fonts

  + Olivier Blin <oblin@mandriva.com>
    - rebuild for _mesa_update_draw_buffer_bounds fix (#25555)
    - fix freeze on VT switch when using AIGLX (#24559) using temporary patch from https://bugs.freedesktop.org/show_bug.cgi?id=7916
    - bump release
    - add XkbGetKeyboard (thanks to Pixel for the debugging, #24612)

  + Pixel <pixel@mandriva.com>
    - adapt background color (as requested by our graphic team)
    - (minor) remove old source
    - fix default font path (nb: /usr/share/fonts is not valid, /usr/share/fonts/misc is)
    - named colors are transformed by the X server, so ensure rgb.txt is there by requiring it in x11-server-xorg

  + Antonio Hobmeir Neto <neto@mandriva.com>
    - x11-server-xorg needs x11-font-alias (#22695)

  + Helio Chissini de Castro <helio@mandriva.com>
    - Directories are comma separated
    - Fixed correct new font path. Before the change, server was tied to one
      specific hardcoded directory %%_libdir/X11/fonts, but fonts are located on /usr/lib/X11/fonts
      so that's explain why fixing XFS for x86_64 isn't work for all X applications.
      Now the standard font dir is /usr/share/fonts, but X will look for old paths
      too, for legacy reasons, including the non 64 versionated lib/X11.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix too long descriptions
    - fix build on x86_64

  + Frederic Crozat <fcrozat@mandriva.com>
    - Patch6 : don't change drm device permission unless asked (patch from libdrm)

  + Andreas Hasenack <andreas@mandriva.com>
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway

  + Laurent Montel <lmontel@mandriva.com>
    - Fix conflict

